#include <VirtualWire.h>
const int transmit_pin = 49; //Il pin da dove i dati vengono trasmessi
const int transmit_en_pin = 48; //Ogni qualvolta viene trasmesso un dato questo pin va basso
char msg[2] = {0}; //Array dove viene memorizzato il dato da spedire
byte LED[] = {22,23,24,25,26,27,28,29};
byte TASTO[] = {53,52,51,50,10,11,12,13};
char indirizzo[] = {'0','1','2','3','4','5','6','7'};
char flag[] = {'0','0','0','0','0','0','0','0'};
int i;
void utenza(int);
void spedisci(int );
void setup()
{
      pinMode(LED[0], OUTPUT); //Led tasto 
      digitalWrite(LED[0], LOW); //Led tasto spento
      pinMode(LED[1], OUTPUT); //Led tasto 
      digitalWrite(LED[1], LOW); //Led tasto spento
      pinMode(LED[2], OUTPUT); //Led tasto 
      digitalWrite(LED[2], LOW); //Led tasto spento
      pinMode(LED[3], OUTPUT); //Led tasto 
      digitalWrite(LED[3], LOW); //Led tasto spento
      pinMode(LED[4], OUTPUT); //Led tasto 
      digitalWrite(LED[4], LOW); //Led tasto spento
      pinMode(LED[5], OUTPUT); //Led tasto 
      digitalWrite(LED[5], LOW); //Led tasto spento
      pinMode(LED[6], OUTPUT); //Led tasto 
      digitalWrite(LED[6], LOW); //Led tasto spento
      pinMode(LED[7], OUTPUT); //Led tasto 
      digitalWrite(LED[7], LOW); //Led tasto spento
      
      vw_set_tx_pin(transmit_pin); //Setta il pin di uscita dati
      vw_set_ptt_pin(transmit_en_pin); //Setta il pin PTT
      vw_set_ptt_inverted(true); // PTT attivo basso
      vw_setup(2000);  
}
void loop()
{  
  utenza(0);
  utenza(1); 
  utenza(2); 
  utenza(3); 
  utenza(4); 
  utenza(5); 
  utenza(6); 
  utenza(7); 
  for(i = 0 ; i < 8 ; ++i)
    spedisci(i);   
}
void utenza(int i)
{
  if(digitalRead(TASTO[i]) == 0)
      {
        if(flag[i] == '0')
        {
           digitalWrite(LED[i], HIGH);
           flag[i] = '1';
        }
        else
        {
           digitalWrite(LED[i], LOW);
           flag[i] = '0';
        }
        while(digitalRead(TASTO[i]) == 0);      
      }                           
}
void spedisci(int i)
{
   msg[0] = indirizzo[i];
   msg[1] = flag[i];
   vw_send(msg, strlen(msg)); //Spedisce il dato e la lunghezza dell'array
   vw_wait_tx(); // Wait until the whole message is gone 
}
