#include <VirtualWire.h>
const int receive_pin = 4; // Pin dove vengono ricevuti i dati
const int rele = 5;
char buf[2] = {'0'};
byte buflen = 2;
char indirizzo = '0';
void setup()
{
    pinMode(rele, OUTPUT);
    digitalWrite(rele, LOW);
    vw_setup(2000);   // Bits per sec
    vw_set_rx_pin(receive_pin); //Setta il pin per la ricezione dati 
}
void loop() 
{
      vw_rx_start(); // Start the receiver PLL running
      vw_wait_rx(); //Attende l'arrivo del dato
      vw_get_message(buf, &buflen); //Legge il dato e la sua lunghezza      
      vw_rx_stop(); //Ferma la ricezione
      if(buf[0] == indirizzo)
      {        
        if(buf[1] == '0')
         {             
            digitalWrite(rele, LOW);
         }
         else
         {            
            digitalWrite(rele, HIGH);
         }
      }       
}
